Imports System.Web.Services
Imports System.Xml
Imports Html2XmlService
Imports System.Configuration

Namespace ReflectionIT.WebServices.StockServices

    <WebService(Namespace:="http://www.reflectionit.nl/webservices/", Description:="StockServices created by <a href=http://www.reflectionit.nl>Reflection IT</a>.")> _
    Public Class StockServices
        Inherits System.Web.Services.WebService

#Region " Web Services Designer Generated Code "

        Public Sub New()
            MyBase.New()

            'This call is required by the Web Services Designer.
            InitializeComponent()

            'Add your own initialization code after the InitializeComponent() call

        End Sub

        'Required by the Web Services Designer
        Private components As System.ComponentModel.Container

        'NOTE: The following procedure is required by the Web Services Designer
        'It can be modified using the Web Services Designer.  
        'Do not modify it using the code editor.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
            components = New System.ComponentModel.Container()
        End Sub

        Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
            'CODEGEN: This procedure is required by the Web Services Designer
            'Do not modify it using the code editor.
        End Sub

#End Region

        <WebMethod(Description:="Get the Yahoo stock quote.")> _
           Public Function GetStockQuote(ByVal symbol As String) As Double

            ' Build the Url
            Dim url As String = "http://finance.yahoo.com/q?s=" + symbol + "&d=v1"
            'url = @"http://localhost/y.htm";

            ' Get the XmlDocument using the Html2Xml WebServices
            Dim xml As XmlDocument = New XmlDocument()
            xml.LoadXml(New Html2XmlService.Html2XmlServices().Url2XmlString(url))

            ' Find the Nodes using a XPath expression
            Dim l As XmlNodeList = xml.SelectNodes(ConfigurationSettings.AppSettings("XPath").ToString())

            ' Validate and return value
            If (l.Count <> 1) Then
                Throw New Exception("symbol not found.")
            Else
                Return Double.Parse(l(0).InnerXml, System.Globalization.CultureInfo.InvariantCulture())
            End If
        End Function

    End Class

End Namespace